include easypak.e

-- this function is from map.e
global integer indice

function getcs(sequence data)
	integer temp
	temp=data[indice]
	indice=indice+1
	if indice>length(data)+1 then
		abort(0)
	end if
	return temp
end function

function grow_deep(sequence data, integer y_length, integer x_length)
	integer index
	sequence new
	new={}
	for times=1 to y_length do
		new=new&0
	end for
	for times=1 to length(new) do
		new[times]=repeat(0,x_length)
	end for
	index=1
	for times=1 to y_length do
		for again=1 to x_length do
			new[times][again]=data[index]
			index=index+1
		end for
	end for
	return new
end function

function read_bitmaps(sequence filename)
	atom filenumber
	sequence bitmaps
	sequence palete
	object junk,multiuse
	sequence muse
	integer indexes
	integer x_size
	integer y_size

	indice=1
	bitmaps={}
	palete={}
	junk={}

	filenumber=open(filename,"r")
	while 1 do
		multiuse=gets(filenumber)
		if atom(multiuse) then
			if multiuse=-1 then
				exit
			end if
		end if
		junk=junk&multiuse
	end while
	close(filenumber)

	for times=1 to length(junk) do
		if junk[times]=255 then
			junk[times]=26
		elsif junk[times]=254 then
			junk[times]=13
		end if
	end for

	for times=1 to 256 do
		palete=append(palete,{getcs(junk),getcs(junk),getcs(junk)}) -- palete read
	end for

	indexes=getcs(junk)+getcs(junk) -- got number of bitmaps
	for times=1 to indexes do
		muse={}
		x_size=getcs(junk)+getcs(junk)
		y_size=getcs(junk)+getcs(junk)
		for again=1 to x_size*y_size do
			muse=append(muse,getcs(junk))
		end for
		bitmaps=append(bitmaps,grow_deep(muse,y_size,x_size))
	end for

	return {palete,bitmaps}
end function

atom screen, key
object mouse_data
sequence temp,palete, event

load_font("future.fnt")
temp=read_bitmaps("button.dat")
palete=temp[1]
temp=temp[2]
-- 31 white 1 black 84 bblue 90 blue
allocate_button(1,temp[1],temp[2])
allocate_menu(1,"Test",{"Test","Test","Test"},{31,1,84,95},{9,9})

screen=graphics_mode(19)
all_palette(palete/4)

put_button(1,{10,10})
put_menu(1,{10,50})
mouse_pointer(1)

while 1 do
	mouse_data=get_event()
	if sequence(mouse_data) then
		if length(mouse_data)=3 then
			if mouse_data[1]!=1 then
				event="Clicked no object"
				exit
			end if
		elsif length(mouse_data)=2 then
			event="Clicked <Click> button"
			exit
		elsif length(mouse_data)=4 then
			if mouse_data[3]=1 then
				event="Clicked the first Test option!"
				exit
			elsif mouse_data[3]=2 then
				event="Clicked the second Test option!"
				exit
			elsif mouse_data[3]=3 then
				event="Clicked the third Test option!"
				exit
			end if
		end if
	end if
end while

mouse_pointer(0)
print_sequence({10,100},event,95,83,0)
mouse_pointer(1)
key=wait_key()
screen=graphics_mode(-1)
